### THIS FILE IS AUTOGENERATED. DO NOT EDIT THIS FILE DIRECTLY ###
from .instance_pb2_grpc import *
from . import instance_pb2
from minFQ.rpc.instance_pb2 import *
from minFQ.rpc._support import MessageWrapper, ArgumentError

__all__ = [
    "InstanceService",
    "GetVersionInfoRequest",
    "GetVersionInfoResponse",
    "GetOutputDirectoriesRequest",
    "OutputDirectories",
    "GetDefaultOutputDirectoriesRequest",
    "SetOutputDirectoryRequest",
    "SetOutputDirectoryResponse",
    "SetReadsDirectoryRequest",
    "SetReadsDirectoryResponse",
    "FilesystemDiskSpaceInfo",
    "GetDiskSpaceInfoRequest",
    "GetDiskSpaceInfoResponse",
    "GetMachineIdRequest",
    "GetMachineIdResponse",
    "GetHostTypeRequest",
    "GetHostTypeResponse",
]

class InstanceService(object):
    def __init__(self, channel):
        self._stub = InstanceServiceStub(channel)
        self._pb = instance_pb2

    def get_version_info(self, _message=None, _timeout=None, **kwargs):
        """
        Current version information includes:
        - Minknow version
        - Protocols version

        :rtype: GetVersionInfoResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_version_info(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetVersionInfoRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_version_info got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_version_info(_message, timeout=_timeout), unwraps=[])

    def get_output_directories(self, _message=None, _timeout=None, **kwargs):
        """
        Returns various directory locations where minknow is outputting data. The paths are absolute paths, 
        local to the machine where minknow is installed

        the `output` base directory can be changed internally
        the `logs` directory will not be changed and can be stored
        the `reads` directory is determined  by the read writer config

        :rtype: OutputDirectories
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_output_directories(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetOutputDirectoriesRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_output_directories got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_output_directories(_message, timeout=_timeout), unwraps=[])

    def get_default_output_directories(self, _message=None, _timeout=None, **kwargs):
        """
        See `get_output_directories`, but this will always return the paths that are defined in the config when the instance
        of minknow has started

        Since 1.11

        :rtype: OutputDirectories
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_default_output_directories(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetDefaultOutputDirectoriesRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_default_output_directories got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_default_output_directories(_message, timeout=_timeout), unwraps=[])

    def set_output_directory(self, _message=None, _timeout=None, **kwargs):
        """
        Set the base directory to where all data will be output. Must be an absolute directory

        Fails with INVALID_ARGUMENT if `value` is not absolute.
        Fails with FAILED_PRECONDITION if this is called during acquisition

        Since 1.11

        :param path:
        :rtype: SetOutputDirectoryResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.set_output_directory(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = SetOutputDirectoryRequest()

        if 'path' in kwargs:
            unused_args.remove('path')
            _message.path = kwargs['path']

        if len(unused_args) > 0:
            raise ArgumentError("set_output_directory got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.set_output_directory(_message, timeout=_timeout), unwraps=[])

    def set_reads_directory(self, _message=None, _timeout=None, **kwargs):
        """
        Set the reads directory where read files (hdf5, fastq, protobuf) will be output

        Fails with INVALID_ARGUMENT if `value` is not absolute.
        Fails with FAILED_PRECONDITION if this is called during acquisition

        Since 1.12

        :param path:
        :rtype: SetReadsDirectoryResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.set_reads_directory(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = SetReadsDirectoryRequest()

        if 'path' in kwargs:
            unused_args.remove('path')
            _message.path = kwargs['path']

        if len(unused_args) > 0:
            raise ArgumentError("set_reads_directory got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.set_reads_directory(_message, timeout=_timeout), unwraps=[])

    def get_disk_space_info(self, _message=None, _timeout=None, **kwargs):
        """
        Returns information about the amount of disk space available, how much
        space is needed to stop an experiment cleanly and if MinKNOW thinks
        that the free disk-space is approaching or past this limit

        Since 1.11

        :rtype: GetDiskSpaceInfoResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_disk_space_info(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetDiskSpaceInfoRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_disk_space_info got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_disk_space_info(_message, timeout=_timeout), unwraps=[])

    def get_machine_id(self, _message=None, _timeout=None, **kwargs):
        """
        Find the machine id MinKNOW uses for this machine.

        This is expected to be a descriptive string for the machine, MinKNOW currently uses the network hostname.

        note: This is the identifier used when sending telemetry data for this instance.

        Since 1.11

        :rtype: GetMachineIdResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_machine_id(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetMachineIdRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_machine_id got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_machine_id(_message, timeout=_timeout), unwraps=[])

    def get_host_type(self, _message=None, _timeout=None, **kwargs):
        """
        Find the host type MinKNOW is running on.

        This data describes the type of machine which MinKNOW is running on.

        Since 1.14

        :rtype: GetHostTypeResponse
        """
        if _message is not None:
            return MessageWrapper(self._stub.get_host_type(_message, timeout=_timeout), unwraps=[])

        unused_args = set(kwargs.keys())

        _message = GetHostTypeRequest()

        if len(unused_args) > 0:
            raise ArgumentError("get_host_type got unexpected keyword arguments '{}'".format("', '".join(unused_args)))
        return MessageWrapper(self._stub.get_host_type(_message, timeout=_timeout), unwraps=[])


